////////////////////////////////////////////////////////
//// Rewrite of gtk_gedreport ported to the GDXlib
//// 0.2.1 slight of interface change
////
//// Written by Michael Gibson
//// This is GPLed Software
///////////////////////////////////////////////////////

#include <stdio.h>
#include <string.h>

#ifdef WIN32
  #include "GDXlib.h"
#endif

#ifndef WIN32
  #include "GDXlib.h"
#endif


char *r_version="0.2.0";

char gedfile[50];
char head1[50],
      head2[50],
      head3[50],
      head4[50],
      head5[50];
char message[50];

///////////////////////////////////
//// read head of file
//////////////////////////////////
void read_head(void){

  FILE *filep1;
  int x;

  printf("start head read\n");
  filep1=fopen(gedfile,"r");

  fgets(head1,50,filep1);
  fgets(head2,50,filep1);
  fgets(head3,50,filep1);
  fgets(head4,50,filep1);
  fgets(head5,50,filep1);

  for(x=0;x<50;x++){
    if(head1[x]=='\0' || head1[x]=='\r' || head1[x]=='\n'){
       head1[x]= ' ';
    }
    if(head2[x]=='\0' || head2[x]=='\r' || head2[x]=='\n'){
       head2[x]= ' ';
    }
    if(head3[x]=='\0' || head3[x]=='\r' || head3[x]=='\n'){
       head3[x]= ' ';
    }
    if(head4[x]=='\0' || head4[x]=='\r' || head4[x]=='\n'){
       head4[x]= ' ';
    }
    if(head5[x]=='\0' || head5[x]=='\r' || head5[x]=='\n'){
       head5[x]= ' ';
    }
  }

  fclose(filep1);
  printf("end head read\n");
}



////////////////////////
//// done message
////////////////////////
void done_message(void) {
                                                                                                                                              
   x_msgbox(5,message,"Done","fixed",50);

}


////////////////////////
//// about message
////////////////////////
void about_message(void) {

   x_imgbox("images/about.xpm","About");

}



////////////////////////////////////////////////////////////
//// surname_report 
///////////////////////////////////////////////////////////
void surname_report()
{
  char systemcall[80];
  sprintf(systemcall,"./gedreport2 -s %s > %s.sn.html",gedfile,gedfile);
  system(systemcall);
  strcpy(message , "The surname report is now completed.");
  done_message();
} 

////////////////////////////////////////////////////////////
//// INDI report 
////////////////////////////////////////////////////////////
void indi_report( )
{
  char systemcall[80];
  sprintf(systemcall,"./gedreport2 -i %s > %s.in.html",gedfile,gedfile);
  system(systemcall);
  strcpy(message , "The individuals report is now completed.");
  done_message();
}

/////////////////////////////////////////////////////////////
//// Family report 
////////////////////////////////////////////////////////////
void fam_report( )
{
  char systemcall[80];
  sprintf(systemcall,"./gedreport2 -f %s > %s.fam.html",gedfile,gedfile);
  system(systemcall);
  strcpy(message , "The family report is now completed.");
  done_message();
}

/////////////////////////////////////////////////////
///// quit app
///////////////////////////////////////////////////// 
void destroy( )
{
    gdx_closewindow(); 
}



void button_help(void)
{

 x_imgbox("images/helptext.xpm","Help");

}

////////////////////////////////////////////////////
//// main
////////////////////////////////////////////////////
int main(int argc, char *argv[])
{
  int show_head=0;
  char option;

  int button1,button3,button4,button5;
  int label1,label2,label3,label4, label5;

  int menubar;
  int menuitem1_menu1;
  int menuitem1_menu2, menuitem2_menu2, menuitem3_menu2;
  int menuitem1_menu3, menuitem2_menu3;
  int menu1,menu2,menu3;

  printf("start gui\n");

  x_open();
  gdx_window("GEDCOM HTML Report", 450, 190);
  gdx_setwindowbg("images/bg.xpm",1);


  if(argc==2||argc==3){
    sprintf(gedfile,"%s",argv[1]);
    printf("%s = filename\n",gedfile);
  }
  else{
    sprintf(gedfile,"family.ged");
    printf("%s = filename\n",gedfile);
  }

  if(argc==3){
    if(argv[2][0]=='-'){
      option=argv[2][1];
    }
  }

  if(option=='h'){
      show_head=1;
      printf("show head is on\n");
      read_head();
  }
  else{
      printf("show head is off\n");
  }


  gdx_label(gedfile,4,150,1);

  if(show_head==1){
    gdx_label(" Head ", 130, 85, 1);
    label1=gdx_label(head1, 130, 100, 1);
    gdx_setlabelbg("images/white.xpm",1,label1); 
    label2=gdx_label(head2, 130, 115, 1);
    gdx_setlabelbg("images/white.xpm",1,label2);
    label3=gdx_label(head3, 130, 130, 1);
    gdx_setlabelbg("images/white.xpm",1,label3);
    label4=gdx_label(head4, 130, 145, 1);
    gdx_setlabelbg("images/white.xpm",1,label4);
    label5=gdx_label(head5, 130, 160, 1);
    gdx_setlabelbg("images/white.xpm",1,label5); 
  }


//buttons

  //button1 = gdx_button(5,50,"Close Window", destroy);
  //gdx_set_button_color(button1,X_RED);

  button1 = gdx_imagebutton(5,22,"images/close.xpm",destroy);

  button3 = gdx_imagebutton(35, 22, "images/sn.xpm", surname_report);
  button4 = gdx_imagebutton(65, 22, "images/ind.xpm", indi_report);
  button5 = gdx_imagebutton(95, 22, "images/fam.xpm",fam_report);

//menus

 menubar = gdx_menubar();

 menu1 = gdx_menu(menubar,"File");
 menu2 = gdx_menu(menubar,"Reports");
 menu3 = gdx_menu(menubar,"Help");

 menuitem1_menu1 = gdx_menuitem(menu1,"Quit",destroy);

 menuitem1_menu2 = gdx_menuitem(menu2,"Surname",surname_report);
 menuitem2_menu2 = gdx_menuitem(menu2,"Individual",indi_report);
 menuitem3_menu2 = gdx_menuitem(menu2,"Family",fam_report);

 menuitem1_menu3 = gdx_menuitem(menu3,"About",about_message);
 menuitem2_menu3 = gdx_menuitem(menu3,"Button Help", button_help);

  gdx_main();
  x_close();
  return 0;
}

 
