/// master.c
/// write GEDCOM files to GedML XML
/// writen by Michael Gibson
/// Released under the GPL
/// copyright 2004-2007
# include <stdio.h>
# include <string.h>

char filename[50];
char last_action[4];

char indi_name[9999][110];
char indi_surname[9999][110];
char indi_fullname_tag[9999][220];

char indi_sex[9999];
char indi_sex_tag[9999][100];

char indi_occu[9999][110];
char indi_note[9999][110];
char indi_educ[9999][110];
char indi_reli[9999][110];

char indi_birt_date[9999][110];
char indi_birtdate_tag[9999][190];

char indi_birt_plac[9999][110];
char indi_birtplac_tag[9999][190];

char indi_birt_note[9999][110];

char indi_deat_date[9999][110];
char indi_deatdate_tag[9999][190];

char indi_deat_plac[9999][110];
char indi_deat_note[9999][110];
char indi_buri_date[9999][110];
char indi_buri_plac[9999][110];
char indi_buri_note[9999][110];
char indi_crem_plac[9999][110];
char indi_chan_date[9999][110];

char fam_husb[1900][110];
char fam_wife[1900][110];
char fam_chil[1900][110];
char fam_marr_date[1900][110];
char fam_marr_plac[1900][110];
char fam_marr_note[1900][110];
char fam_div_date[1900][110];
char fam_div_plac[1900][110];
char fam_div_note[1900][110];

char indi[6];
char fam[6];

int lines_of_data=0;
int number_of_names=0;
int indi_r=0;
int fam_r=0;
int id_pointer;

char temp[110];
FILE *fp;

////////////////////////////////////
///
///////////////////////////////////
void write_xml()
{

  int loop;

  fp=fopen("family.xml","w+");

  fprintf(fp,"<GED>\n");
  fprintf(fp," <HEAD>\n");
  fprintf(fp,"  <SOUR>GEDXchange</SOUR>\n");
  fprintf(fp," </HEAD>\n");

  for(loop=1;loop<9999;loop++){

    fprintf(fp," <INDI ID=\"I%04d\">\n",loop);
    fprintf(fp,"%s",indi_fullname_tag[loop]);
    fprintf(fp,"%s",indi_sex_tag[loop]);
    fprintf(fp,"  <BIRT>\n");
    fprintf(fp,"%s",indi_birtdate_tag[loop]);
    fprintf(fp,"%s",indi_birtplac_tag[loop]);
    fprintf(fp,"  </BIRT>\n");
    fprintf(fp,"  <DEAT>\n");
    fprintf(fp,"%s",indi_deatdate_tag[loop]);
    fprintf(fp,"  </DEAT>\n");
    fprintf(fp," </INDI>\n");

    if(indi_name[0] =='\0') loop=10000;

  }
  fprintf(fp,"</GED>\n");

  fclose(fp);

}

/////////////////////////////////////
/// create xml tags
/////////////////////////////////////
void create_tags()
{

  int loop;

  for(loop=1;loop<9999;loop++){
    sprintf(indi_fullname_tag[loop],"  <NAME>%s<S>%s</S></NAME>\n",indi_name[loop],indi_surname[loop]);
    if(indi_sex[loop] != '\0') sprintf(indi_sex_tag[loop],     "  <SEX>%c</SEX>\n",indi_sex[loop]);
    sprintf(indi_birtdate_tag[loop],"   <DATE>%s</DATE>\n",indi_birt_date[loop]);
    sprintf(indi_birtplac_tag[loop],"   <PLAC>%s</PLAC>\n",indi_birt_plac[loop]);
    sprintf(indi_deatdate_tag[loop],"   <DATE>%s</DATE>\n",indi_deat_date[loop]);
  }


}
///////////////////////////////////////
/// read_gedcom
//////////////////////////////////////
void read_gedcom(void)
{
int x,y;

fp=fopen(filename,"r+");

do{
  fgets(temp,90,fp);
  if(temp[0]=='1' && temp[2]=='N' && temp[3]=='A' && last_action[0]=='I' &&  last_action[1]=='N'){ ///1 NAME

     //find total names
     number_of_names++;

     //copies only the name
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
     strcpy(indi_name[indi_r],temp);

     //grab given name
     x=0;
     do{
       if(indi_name[indi_r][x] == '/') indi_name[indi_r][x] = '\0';
       x++;
     }while(indi_name[indi_r][x-1] != '\0');

     //find surname
     y=0;
     do{
        indi_surname[indi_r][y]=indi_name[indi_r][x];
        x++;
        y++;
     }while(indi_name[indi_r][x] != '/' && indi_name[indi_r][x] != '\0');
  }

///// Catches
///// 0 FAM -> 1 HUSB
  if(temp[0]=='1' && temp[2]=='H' && temp[3]=='U'){   ///1 HUSB
      for(x=8;x<90;x++){
         if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';}
      sprintf(fam_husb[fam_r],"%c%c%c%c",temp[9],temp[10],temp[11],temp[12]);
      id_pointer=atoi(fam_husb[fam_r]);
  }

///// Catches
///// 0 FAM -> 1 WIFE
  if(temp[0]=='1' && temp[2]=='W' && temp[3]=='I'){ //1 WIFE
      for(x=8;x<90;x++){
         if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';}
      sprintf(fam_wife[fam_r],"%c%c%c%c",temp[9],temp[10],temp[11],temp[12]);
      id_pointer=atoi(fam_wife[fam_r]);
  }

///// Catches
///// 0 FAM -> 1 CHIL
  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='H' && temp[4]=='I'){ //1 CHIL
      for(x=8;x<90;x++){
         if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';}
      sprintf(fam_chil[fam_r],"%c%c%c%c",temp[9],temp[10],temp[11],temp[12]);
      id_pointer=atoi(fam_chil[fam_r]);
  }

///// Catches
///// 0 INDI -> 1 NOTE
  if(temp[0]=='1' && temp[2]=='N' && temp[3]=='O'){ //1 NOTE
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
     strcpy(indi_note[indi_r],temp);
  }


//// Catches
//// 0 HEAD -> 1 SOUR
  if(temp[0]=='1' && temp[2]=='S' && temp[3]=='O' && temp[4]== 'R'){ //1 SOUR
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
  }

//// Catches
//// 0 HEAD -> 1 SOUR -> 2 CORP
  if(temp[0]=='2' && temp[2]=='C' && temp[3]=='O' && temp[4]== 'R'){ //2 CORP
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
  }

//// Catches
//// 0 HEAD -> 1 GEDC -> 2 FORM
  if(temp[0]=='2' && temp[2]=='F' && temp[3]=='O' && temp[4]== 'R'){ //2 FORM
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
  }

//// Catches
//// 0 HEAD -> 1 SOUR -> 2 VERS
//// 0 HEAD -> 1 GEDC -> 2 VERS
  if(temp[0]=='2' && temp[2]=='V' && temp[3]=='E'){ //2 VERS
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
  }

///// Catches
///// 0 HEAD -> 1 SOUR -> 2 NAME
  if(temp[0]=='2' && temp[2]=='N' && temp[3]=='A'){ //2 NAME
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
  }


///// Catches
///// 0 HEAD -> 1 DATE
  if(temp[0]=='1' && temp[2]=='D' && temp[3]=='A'){ //1 DATE
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
  }

///// Catches
///// 0 HEAD -> 1 DATE -> 2 TIME
  if(temp[0]=='2' && temp[2]=='T' && temp[3]=='I'){ //2 TIME
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
  }


//// Catches
//// 0 HEAD -> 1 FILE
  if(temp[0]=='1' && temp[2]=='F' && temp[3]=='I'){ //1 FILE
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
  }

//// Catches
//// 0 HEAD -> 1 CHAR
  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='H' && temp[4]=='A' && temp[5]=='R'){ //1 CHAR
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
  }

//// Catches
//// 0 INDI -> 1 BIRT -> 2 NOTE
//// 0 INDI -> 1 DEAT -> 2 NOTE
//// 0 INDI -> 1 BURI -> 2 NOTE
  if(temp[0]=='2' && temp[2]=='N' && temp[3]=='O'){ //2 NOTE
     for(x=7;x<90;x++){
       if(temp[x]=='\n') temp[x]='\0';
       temp[x-7]=temp[x];
     }
     if(last_action[0]=='B' && last_action[1]=='I'){
       strcpy(indi_birt_note[indi_r],temp);
     }
     if(last_action[0]=='D' && last_action[1]=='E'){
       strcpy(indi_deat_note[indi_r],temp);
     }
     if(last_action[0]=='B' && last_action[1]=='U'){
       strcpy(indi_buri_note[indi_r],temp);
     }
  }

//// Catches
//// 0 INDI -> 1 BIRT -> 2 DATE
//// 0 INDI -> 1 DEAT -> 2 DATE
//// 0 INDI -> 1 BURI -> 2 DATE
//// 0 INDI -> 1 CHAN -> 2 DATE
//// 0 FAM  -> 1 MARR -> 2 DATE
//// 0 FAM  -> 1 DIV  -> 2 DATE
  if(temp[0]=='2' && temp[2]=='D' && temp[3]=='A'){ //2 DATE
     for(x=7;x<90;x++){
       if(temp[x]=='\n') temp[x]='\0';
       temp[x-7]=temp[x];
     }

     if(last_action[0]=='B' && last_action[1]=='I'){
       strcpy(indi_birt_date[indi_r],temp);
     }
     if(last_action[0]=='D' && last_action[1]=='E'){
       strcpy(indi_deat_date[indi_r],temp);
     }
     if(last_action[0]=='B' && last_action[1]=='U'){
       strcpy(indi_buri_date[indi_r],temp);
     }
     if(last_action[0]=='C' && last_action[1]=='H'){
       strcpy(indi_chan_date[indi_r],temp);
     }
     if(last_action[0]=='M' && last_action[1]=='A'){
       strcpy(fam_marr_date[fam_r],temp);
     }
      if(last_action[0]=='D' && last_action[1]=='I'){
       strcpy(fam_div_date[fam_r],temp);
     }
  }

///// Catches
///// 0 INDI -> 1 BIRT -> 2 PLAC
///// 0 INDI -> 1 DEAT -> 2 PLAC
///// 0 INDI -> 1 BURI -> 2 PLAC
///// 0 INDI -> 1 CREM -> 2 PLAC
///// 0 FAM  -> 1 MARR -> 2 PLAC
///// 0 FAM  -> 1 DIV  -> 2 PLAC
  if(temp[0]=='2' && temp[2]=='P' && temp[3]=='L'){ //2 PLAC
     for(x=7;x<90;x++){
       if(temp[x]=='\n') temp[x]='\0';
       temp[x-7]=temp[x];
     }



     if(last_action[0]=='B' && last_action[1]=='I'){
       strcpy(indi_birt_plac[indi_r],temp);
     }
     if(last_action[0]=='D' && last_action[1]=='E'){
       strcpy(indi_deat_plac[indi_r],temp);
     }
     if(last_action[0]=='B' && last_action[1]=='U'){
       strcpy(indi_buri_plac[indi_r],temp);
     }
     if(last_action[0]=='C' && last_action[1]=='R'){
       strcpy(indi_crem_plac[indi_r],temp);
     }
     if(last_action[0]=='M' && last_action[1]=='A'){
       strcpy(fam_marr_plac[fam_r],temp);
     }
      if(last_action[0]=='D' && last_action[1]=='I'){
       strcpy(fam_div_plac[fam_r],temp);
     }
  }

///// Catches
///// 0 INDI -> 1 OBJE -> 2 FILE
  if(temp[0]=='2' && temp[2]=='F' && temp[3]=='I'){ //2 FILE
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
     if(last_action[0]=='O' && last_action[1]=='B'){
       strcpy(indi_birt_plac[indi_r],temp);
     }
  }

///// Catches
///// 0 INDI -> 1 EDUC
  if(temp[0]=='1' && temp[2]=='E' && temp[3]=='D'){ //1 EDUC
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
     strcpy(indi_educ[indi_r],temp);
  }
///// Catches
///// 0 INDI -> 1 OCCU
  if(temp[0]=='1' && temp[2]=='O' && temp[3]=='C'){ //1 OCCU
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
     strcpy(indi_occu[indi_r],temp);
  }
  if(temp[0]=='1' && temp[2]=='R' && temp[3]=='E'){ //1 RELI
     for(x=7;x<90;x++){temp[x-7]=temp[x];}
     strcpy(indi_reli[indi_r],temp);
  }
  if(temp[0]=='1' && temp[2]=='S' && temp[3]=='E'){ //1 SEX
     indi_sex[indi_r]=temp[6];
  }
  if(temp[0]=='1' && temp[2]=='B' && temp[3]=='I'){ //1 BIRT
     strcpy(last_action,"BIRT");
  }
  if(temp[0]=='1' && temp[2]=='D' && temp[3]=='E' && temp[4] =='A'){ //1 DEAT
     strcpy(last_action,"DEAT");
  }
  if(temp[0]=='1' && temp[2]=='B' && temp[3]=='U' && temp[4] =='R'){ //1 BURI
     strcpy(last_action,"BURI");
  }
  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='R' && temp[4] =='E'){ //1 CREM
     strcpy(last_action,"CREM");
  }
  if(temp[0]=='1' && temp[2]=='C' && temp[3]=='H' && temp[4] =='A' && temp[5]=='N'){ //1 CHAN
     strcpy(last_action,"CHAN");
  }

  if(temp[0]=='1' && temp[2]=='O' && temp[3]=='B' && temp[4] =='J' && temp[5]=='E'){ //1 OBJE
     strcpy(last_action,"OBJE");
  }
  if(temp[0]=='1' && temp[2]=='M' && temp[3]=='A' && temp[4] =='R'){ //1 MARR
     strcpy(last_action,"MARR");
  }
  if(temp[0]=='1' && temp[2]=='D' && temp[3]=='I' && temp[4] =='V'){ //1 DIV
     strcpy(last_action,"DIV");
  }

  //0 @I
  if(temp[0]=='0' && temp[1]==' ' && temp[2]=='@' && temp[3] =='I'){ 
     strcpy(last_action,"INDI");
  }

 
  if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){ //Individual 0 level start of record
      for(x=5;x<90;x++) if(temp[x]=='@' ||temp[x]=='I') temp[x]=' ';
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      indi_r=atoi(indi);
  }

  if(temp[0]=='0' && temp[2]=='@' && temp[3]=='F'){ //Family 0 level start of record
      for(x=5;x<90;x++) if(temp[x]=='@' ||temp[x]=='F') temp[x]=' ';
      sprintf(fam,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      fam_r=atoi(fam);
  }
 lines_of_data++;
}while(temp[0] !='0' || temp[2] !='T');
       
fclose(fp);


}


////////////////////////////////////
// main 
/////////////////////////////////////
int main(int argc, char *argv[])
{

  printf("get filename\n");
  strcpy(filename,argv[1]);
  printf("done\n");
  printf("read filename\n");
  read_gedcom();
  printf("done\n");

  create_tags();

  write_xml();

  return 0;
}


